﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace RoboRace
{
    public partial class Form1 : Form
    {
        char[,] mapa = new char[20, 20];
        Point hrac = new Point();       //point misto vektoru
        char smer;
        string moznePohyby;
        Point poklad = new Point();
        List<Point> miny = new List<Point>();       //pole děr jako min
        string vstup;
        int cisloHry;
        int poc1, poc2, poc3, pocL, pocR, pocZ;
        bool konecHry = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            konecHry = false;
            try
            {
                StringBuilder sb = new StringBuilder();
                //na každou operaci
                byte[] buf = new byte[8192];
                //připravit web na požadavek
                HttpWebRequest request = (HttpWebRequest)
                    WebRequest.Create("http://" + urlBox.Text + "/start");
                //odpověď webu
                HttpWebResponse response = (HttpWebResponse)
                    request.GetResponse();
                //přečíst data
                Stream resStream = response.GetResponseStream();
                string tempString = null;
                int count = 0;
                do
                {
                    //zjistit počet
                    count = resStream.Read(buf, 0, buf.Length);
                    //číst
                    if (count != 0)
                    {
                        // translate from bytes to ASCII text
                        tempString = Encoding.ASCII.GetString(buf, 0, count);
                        // continue building the string
                        sb.Append(tempString);
                    }
                }
                while (count > 0); //ještě něco číst?
                vstup = sb.ToString();
            }
            catch
            {
                MessageBox.Show("Chyba s webem.", "Chyba");
            }

            StreamWriter writer = new StreamWriter("vstup.txt");   //uložení aktuální odpovědi
            writer.Write(vstup);
            writer.Close();
            StreamReader reader = new StreamReader("vstup.txt");   //čtení pole

            cisloHry = Convert.ToInt32(reader.ReadLine().Trim());

            miny.Clear();
            for (int j = 0; j < 20; j++)        //radek (osa y)
            {
                string radek = reader.ReadLine();
                for (int i = 0; i < 20; i++)        //sloupec (osa x)
                {
                    mapa[i, j] = radek[i];
                    if (mapa[i, j] == '#')
                        miny.Add(new Point(i, j));
                    mapa[i, j] = radek[i];
                    if (mapa[i, j] == '$')
                        poklad = new Point(i, j);
                }
            }

            string poloha = reader.ReadLine();      //pozice hrace
            ZjistiPolohu(poloha);
            moznePohyby = reader.ReadLine().ToUpper();     //zjistit možné pohyby
            pohyby.Text = moznePohyby;
            ZpracujMoznosti(moznePohyby);

            reader.Close(); //uzavření readeru

            odeslat.Enabled = true;
            panel.Refresh();
        }

        private void ZpracujMoznosti(string moznePohyby)
        {
            poc1 = 0; poc2 = 0; poc3 = 0; pocL = 0; pocR = 0; pocZ = 0;
            foreach (var znak in moznePohyby)
            {
                switch (znak)
                {
                    case '1':
                        poc1++;
                        break;
                    case '2':
                        poc2++;
                        break;
                    case '3':
                        poc3++;
                        break;
                    case 'L':
                        pocL++;
                        break;
                    case 'R':
                        pocR++;
                        break;
                    case 'Z':
                        pocZ++;
                        break;
                }
            }
        }

        private void ZjistiPolohu(string poloha)
        {
            string cislo;
            if (poloha[1] == ' ')
            {
                cislo = poloha[0].ToString();
                hrac.X = Convert.ToInt32(cislo.Trim());
                if (poloha[3] == ' ')
                {
                    cislo = poloha[2].ToString();
                    hrac.Y = Convert.ToInt32(cislo.Trim());
                    smer = poloha[4];
                }
                else
                {
                    cislo = poloha[3].ToString() + poloha[4].ToString();
                    hrac.Y = Convert.ToInt32(cislo.Trim());
                    smer = poloha[5];
                }
            }
            else
            {
                cislo = poloha[0].ToString() + poloha[1].ToString();
                hrac.X = Convert.ToInt32(cislo.Trim());
                if (poloha[4] == ' ')
                {
                    cislo = poloha[3].ToString();
                    hrac.Y = Convert.ToInt32(cislo.Trim());
                    smer = poloha[5];
                }
                else
                {
                    cislo = poloha[4].ToString() + poloha[5].ToString();
                    hrac.Y = Convert.ToInt32(cislo.Trim());
                    smer = poloha[6];
                }
            }

            hrac.X--;   //zadavany index je jednotku větší
            hrac.Y--;
            smerBox.Text = "Směr: " + smer.ToString();
        }

        private void panel_Paint(object sender, PaintEventArgs e)
        {
            Graphics kp = e.Graphics;
            kp.Clear(Color.White);
            for (int i = 0; i < 20; i++)
            {
                for (int j = 0; j < 20; j++)
                {
                    switch (mapa[i, j])
                    {
                        case 'X':
                            kp.FillRectangle(Brushes.Black, i * 20, j * 20, 20, 20);
                            break;
                        case '#':
                            kp.FillRectangle(Brushes.Red, i * 20, j * 20, 20, 20);
                            break;
                        case '$':
                            kp.FillRectangle(Brushes.Gold, i * 20, j * 20, 20, 20);
                            break;
                    }
                }
            }
            kp.FillEllipse(Brushes.Green, hrac.X * 20 + 3, hrac.Y * 20 + 3, 14, 14);
        }

        private void odeslat_Click(object sender, EventArgs e)
        {
            //ověřit zadané hodnoty
            vybranePohyby.Text = vybranePohyby.Text.ToUpper();
            if (vybranePohyby.Text.Length > 5)
            {
                MessageBox.Show("Můžete zadat maximálně 5 možností.", "Chyba");
                return;
            }

            //provést pohyby
            foreach (var znak in vybranePohyby.Text)
            {
                if (konecHry)
                {
                    odeslat.Enabled = false;
                    return;
                }
                switch (znak)
                {
                    case '1':
                        if (poc1 <= 0)
                            MessageBox.Show("Použil jsi příliš mnoho těchto příkazů: '"
                                + znak.ToString() + "'.", "Chyba");
                        else
                        {
                            PohniSe(1);
                            poc1--;
                        }
                        break;
                    case '2':
                        if (poc2 <= 0)
                            MessageBox.Show("Použil jsi příliš mnoho těchto příkazů: '"
                                + znak.ToString() + "'.", "Chyba");
                        else
                        {
                            PohniSe(1); PohniSe(1);
                            poc2--;
                        }
                        break;
                    case '3':
                        if (poc3 <= 0)
                            MessageBox.Show("Použil jsi příliš mnoho těchto příkazů: '"
                                + znak.ToString() + "'.", "Chyba");
                        else
                        {
                            PohniSe(1); PohniSe(1); PohniSe(1);
                            poc3--;
                            //vzdalenost jen 1, aby se stihla zkontrolovat kolize
                        }
                        break;
                    case 'L':
                        if (pocL <= 0)
                            MessageBox.Show("Použil jsi příliš mnoho těchto příkazů: '"
                                + znak.ToString() + "'.", "Chyba");
                        else
                        {
                            OtocSe(0);
                            pocL--;
                        }
                        break;
                    case 'R':
                        if (pocR <= 0)
                            MessageBox.Show("Použil jsi příliš mnoho těchto příkazů: '"
                                + znak.ToString() + "'.", "Chyba");
                        else
                        {
                            OtocSe(1);
                            pocR--;
                        }
                        break;
                    case 'Z':
                        if (pocZ <= 0)
                            MessageBox.Show("Použil jsi příliš mnoho těchto příkazů: '"
                                + znak.ToString() + "'.", "Chyba");
                        else
                        {
                            PohniSe(-1);
                            pocZ--;
                        }
                        break;
                    default:
                        MessageBox.Show("Chybný příkaz.","Chyba");
                        return;
                        break;
                }
            }
            //znova se zeprat webu
            if (konecHry==false)
            {
                try
                {
                    StringBuilder sb = new StringBuilder();
                    //na každou operaci
                    byte[] buf = new byte[8192];
                    //připravit web na požadavek
                    HttpWebRequest request = (HttpWebRequest)
                        WebRequest.Create("http://" + urlBox.Text + "/kolo?id=" + cisloHry.ToString() +
                            "&pohyby=" + vybranePohyby.Text);
                    //odpověď webu
                    HttpWebResponse response = (HttpWebResponse)
                        request.GetResponse();
                    //přečíst data
                    Stream resStream = response.GetResponseStream();
                    string tempString = null;
                    int count = 0;
                    do
                    {
                        //zjistit počet
                        count = resStream.Read(buf, 0, buf.Length);
                        //číst
                        if (count != 0)
                        {
                            // translate from bytes to ASCII text
                            tempString = Encoding.ASCII.GetString(buf, 0, count);
                            // continue building the string
                            sb.Append(tempString);
                        }
                    }
                    while (count > 0); //ještě něco číst?
                    vstup = sb.ToString();
                }
                catch
                {
                    MessageBox.Show("Chyba s webem.", "Chyba");
                }

                StreamWriter writer = new StreamWriter("vstup.txt");   //uložení aktuální odpovědi
                writer.Write(vstup);
                writer.Close();
                StreamReader reader = new StreamReader("vstup.txt");   //čtení pole

                string prvniRadek = reader.ReadLine().Trim();
                if (prvniRadek == cisloHry.ToString())
                {
                    miny.Clear();
                    for (int j = 0; j < 20; j++)        //radek (osa y)
                    {
                        string radek = reader.ReadLine();
                        for (int i = 0; i < 20; i++)        //sloupec (osa x)
                        {
                            mapa[i, j] = radek[i];
                            if (mapa[i, j] == '#')
                                miny.Add(new Point(i, j));
                            mapa[i, j] = radek[i];
                            if (mapa[i, j] == '$')
                                poklad = new Point(i, j);
                        }
                    }

                    string poloha = reader.ReadLine();      //pozice hrace
                    ZjistiPolohu(poloha);
                    moznePohyby = reader.ReadLine().ToUpper();     //zjistit možné pohyby
                    pohyby.Text = moznePohyby;
                    ZpracujMoznosti(moznePohyby);
                }
                else
                {
                    konecHry = true;
                    MessageBox.Show("Vzhrál jsi. Dosáhl jsi pokladu." + Environment.NewLine +
                    "Cituji: " + prvniRadek, "Konec hry.");
                }
                reader.Close();
            }
        }

        private void OtocSe(int p)
        {
            if (p == 0)
            {
                switch (smer)
                {
                    case 'N':
                        smer = 'L';
                        break;
                    case 'L':
                        smer = 'D';
                        break;
                    case 'D':
                        smer = 'R';
                        break;
                    case 'R':
                        smer = 'N';
                        break;
                }
            }
            else if (p == 1)
            {
                switch (smer)
                {
                    case 'N':
                        smer = 'R';
                        break;
                    case 'R':
                        smer = 'D';
                        break;
                    case 'D':
                        smer = 'L';
                        break;
                    case 'L':
                        smer = 'N';
                        break;
                }
            }
            smerBox.Text = "Směr: " + smer.ToString();
        }

        private void PohniSe(int vzdalenost)
        {
            if (konecHry == false)
            {
                if (smer == 'N')        //nahoru
                    if (hrac.Y > 0)
                    {
                        if (mapa[hrac.X, hrac.Y - vzdalenost] != 'X')
                            hrac.Y--;
                    }
                    else
                    {
                        konecHry = true;
                        MessageBox.Show("Vypadnul jsi z hrací plochy.","Konec hry.");
                    }

                if (smer == 'D')        //dolů
                    if (hrac.Y < 19)
                    {
                        if(mapa[hrac.X, hrac.Y + vzdalenost] != 'X')
                        hrac.Y++;
                    }
                    else
                    {
                        konecHry = true;
                        MessageBox.Show("Vypadnul jsi z hrací plochy.", "Konec hry.");
                    }

                if (smer == 'L')        //vlevo
                    if (hrac.X > 0)
                    {
                        if(mapa[hrac.X - vzdalenost, hrac.Y] != 'X')
                        hrac.X--;
                    }
                    else
                    {
                        konecHry = true;
                        MessageBox.Show("Vypadnul jsi z hrací plochy.", "Konec hry.");
                    }

                if (smer == 'R')        //vpravo
                    if (hrac.X < 19)
                    {
                        if (mapa[hrac.X + vzdalenost, hrac.Y] != 'X')
                        hrac.X++;
                    }
                    else
                    {
                        konecHry = true;
                        MessageBox.Show("Vypadnul jsi z hrací plochy.", "Konec hry.");
                    }
            }
            if (konecHry == false)
            {
                foreach (var mina in miny)
                {
                    if ((hrac.X == mina.X) && (hrac.Y == mina.Y))
                    {
                        konecHry = true;
                        MessageBox.Show("Hráč vybuchl na mině.", "Konec hry.");
                    }
                }
            }
            panel.Refresh();
        }
    }
}
